mod Ex06

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex2_appl_sigma1_sb
  Prefix(80,0,Subsup(Id(0,Ent('sigma'),0),75,Num('1',0),None),
         Fenced(Op('[',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(']',0)))

appldisp/3 Tex3_appl_sigma2_sb
  Prefix(80,0,Subsup(Id(0,Ent('sigma'),0),75,Num('2',0),None),
         Fenced(Op('[',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(']',0)))

appldisp/4 Tex_f4_rec_sr_map
  Prefix(90,2,Subsup(Id(0,'M',0),75,Arg(0),None),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Nested Simple Recursion.  \end 

rem 
  \para \bf  Subsection. Nested Simple Recursion: Case \ft k = 2 \end and One 
  Parameter.  \end 

rem 
  \para \bf  Exercise.  \end 

fun G 'Tex_f1_g'
  G(x1) = x1+1

fun/4 H1 'Tex_f4_h'
  H1(x1,x2,x3,x4) = x1+x2+x3+x4

fun/2 Sb1 'Tex2_appl_sigma1_sb'
  Sb1(x1,x2) = x1+x2

fun/3 Sb2 'Tex3_appl_sigma2_sb'
  Sb2(x1,x2,x3) = x1+x2+x3

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,F(x,Sb1(x,y)),F(x,Sb2(x,y,F(x,Sb1(x,y)))),y)

fun/2 Cvf 'Tex_f2_rec_cvf_f'
  Cvf(0,y) = F(0,y),0,0
  Cvf(x+1,y) = F(x+1,y),Cvf(x,Sb1(x,y)),Cvf(x,Sb2(x,y,F(x,Sb1(x,y))))

loc rem 
  \para \it  Proof.  \end 

fun/4 U 
  U(x,y,t,i) = Foo

fun/4 Map 'Tex_f4_rec_sr_map'
  Map(i,x,y,t) = Foo

fun Full 
  Full(n) = Foo

fun/2 Cvf_is_primrec 'Tex_f2_rec_cvf_f'
  Cvf_is_primrec(x,y) = Foo

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

loc rem 
  \para \it  Binary Trees.  \end 

appldisp/0 Tex_f0_bt_e
  Op(Ent('bull'),0)

appldisp/3 Tex_f3_bt_nd
  Frac(Arg(0),1,Infix(Arg(1),25,3,Op(Ent('mid'),0),Arg(2)))

loc fun/0 E 'Tex_f0_bt_e'
  E = 0,0

loc fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

loc pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

loc fun T2bt 
  T2bt(0) = E
  T2bt(z,l,r) = Nd(z,T2bt(l),T2bt(r))

loc rem 
  \para \it  Debugging.  \end 

loc rem 
  Some useful queries
  0,0 = x,y & F(x,y) = z
  0,0 = x,y & Cvf(x,y) = t
  0,0 = x,y & T2bt Cvf(x,y) = t:Bt
  0,0 = x,y & Cvf_is_primrec(x,y) = t
  0,0 = x,y & T2bt Cvf_is_primrec(x,y) = t:Bt
  0,0 = x,y & F_is_primrec(x,y) = z
  data,0,0 = i,x,y & Cvf(x,y) = t1 & Map(i,x,y,Full(x+1)) = t2 & data+1 = data99
  data,0,0 = i,x,y & T2bt Cvf(x,y) = t1:Bt & T2bt Map(i,x,y,Full(x+1)) = t2:Bt & data+1 = data99

